% Amode field visualization in x-z plane
% Left grating
% grating - freespace

D=zeros(2*L,1);
inc_mode=33;
D(inc_mode)=1;
% d11=zeros(L,1);
% d12=zeros(L,1);
% centx=nx*NBy+ny+1;
% centy=nx*NBy+ny+1;
% d11(centx)=Uy;  % Kx of incident beam
% d12(centy)=Ux;
% D(1:L)=d11;
% D(L+1:2*L)=d12;

C_n=ALR11*D;     % negative coupling coefficient
ET2_temp=ALT12*D; % positive coupling coefficient
HT2_temp=AVh*ET2_temp;

ET2_y=zeros(L,1);
ET2_x=zeros(L,1);
HT2_y=zeros(L,1);
HT2_x=zeros(L,1);

ET2_y=ET2_temp(1:L);
ET2_x=ET2_temp(L+1:2*L);
HT2_y=HT2_temp(1:L);
HT2_x=HT2_temp(L+1:2*L);


ET2x_cof=zeros(NBx,NBy);
ET2y_cof=zeros(NBx,NBy);
ET2z_cof=zeros(NBx,NBy);
HT2x_cof=zeros(NBx,NBy);
HT2y_cof=zeros(NBx,NBy);
HT2z_cof=zeros(NBx,NBy);

for k=1:NBx
   for l=1:NBy
      
      ET2y_cof(k,l)=ET2_y((k-1)*NBy+l);
      ET2x_cof(k,l)=ET2_x((k-1)*NBy+l );
      ET2z_cof(k,l)=-( Akx_vc(k)*ET2x_cof(k,l)+Aky_vc(l)*ET2y_cof(k,l) )/Akz_vc(k,l); 
      HT2y_cof(k,l)=HT2_y((k-1)*NBy+l);
      HT2x_cof(k,l)=HT2_x((k-1)*NBy+l );
      HT2z_cof(k,l)=-( Akx_vc(k)*HT2x_cof(k,l)+Aky_vc(l)*HT2y_cof(k,l) )/Akz_vc(k,l); 
 
   end;
end;

% region II


z_inc=a/9;
x_inc=z_inc;
zz=[0:z_inc:10*aTz-z_inc];
xx=[-aTx/2+x_inc/2:x_inc:aTx/2-x_inc/2];
zz1=zz-(10*aTz-z_inc);              % freespace1
zz2=zz;                 % freespace2

Ey_xz2=zeros(length(xx),length(zz2));
Ex_xz2=zeros(length(xx),length(zz2));
Ez_xz2=zeros(length(xx),length(zz2));

Hy_xz2=zeros(length(xx),length(zz2));
Hx_xz2=zeros(length(xx),length(zz2));
Hz_xz2=zeros(length(xx),length(zz2));

% region II

[z2 x2]=meshgrid(zz2,xx); % region G
y=0;
    for k=1:NBx
         for l=1:NBy
           Ey_xz2=Ey_xz2+ET2y_cof(k,l)*exp(j*Akz_vc(k,l)*z2).*exp(j*( Akx_vc(k)*x2+Aky_vc(l)*y ));   
           Ex_xz2=Ex_xz2+ET2x_cof(k,l)*exp(j*Akz_vc(k,l)*z2).*exp(j*( Akx_vc(k)*x2+Aky_vc(l)*y ));
           Ez_xz2=Ez_xz2+ET2z_cof(k,l)*exp(j*Akz_vc(k,l)*z2).*exp(j*( Akx_vc(k)*x2+Aky_vc(l)*y ));
           
           Hy_xz2=Hy_xz2+HT2y_cof(k,l)*exp(j*Akz_vc(k,l)*z2).*exp(j*( Akx_vc(k)*x2+Aky_vc(l)*y ));   
           Hx_xz2=Hx_xz2+HT2x_cof(k,l)*exp(j*Akz_vc(k,l)*z2).*exp(j*( Akx_vc(k)*x2+Aky_vc(l)*y ));
           Hz_xz2=Hz_xz2+HT2z_cof(k,l)*exp(j*Akz_vc(k,l)*z2).*exp(j*( Akx_vc(k)*x2+Aky_vc(l)*y ));
           end;
        end;
 
        

% Grating region
[xlen zlen]=size(aNG_Ey_xz(:,:,1));      
aGEx_xz=zeros(length(xx),10*zlen);
aGEy_xz=zeros(length(xx),10*zlen);
aGEz_xz=zeros(length(xx),10*zlen);
aGHx_xz=zeros(length(xx),10*zlen);
aGHy_xz=zeros(length(xx),10*zlen);
aGHz_xz=zeros(length(xx),10*zlen);


   for pbm_ind=1:mcnt
       
            aGEx_xz=aGEx_xz+C_n(pbm_ind)*[aNG_Ex_xz(:,:,pbm_ind)*exp(-am_evalue(pbm_ind)*9*Tz) ...
            aNG_Ex_xz(:,:,pbm_ind)*exp(-am_evalue(pbm_ind)*8*Tz) ...
            aNG_Ex_xz(:,:,pbm_ind)*exp(-am_evalue(pbm_ind)*7*Tz) ...    
            aNG_Ex_xz(:,:,pbm_ind)*exp(-am_evalue(pbm_ind)*6*Tz) ...
            aNG_Ex_xz(:,:,pbm_ind)*exp(-am_evalue(pbm_ind)*5*Tz) ...
            aNG_Ex_xz(:,:,pbm_ind)*exp(-am_evalue(pbm_ind)*4*Tz) ...
            aNG_Ex_xz(:,:,pbm_ind)*exp(-am_evalue(pbm_ind)*3*Tz) ...    
            aNG_Ex_xz(:,:,pbm_ind)*exp(-am_evalue(pbm_ind)*2*Tz) ...
            aNG_Ex_xz(:,:,pbm_ind)*exp(-am_evalue(pbm_ind)*Tz) ...
            aNG_Ex_xz(:,:,pbm_ind)]; 
                        
            aGEy_xz=aGEy_xz+C_n(pbm_ind)*[aNG_Ey_xz(:,:,pbm_ind)*exp(-am_evalue(pbm_ind)*9*Tz)...
            aNG_Ey_xz(:,:,pbm_ind)*exp(-am_evalue(pbm_ind)*8*Tz)...    
            aNG_Ey_xz(:,:,pbm_ind)*exp(-am_evalue(pbm_ind)*7*Tz)...
            aNG_Ey_xz(:,:,pbm_ind)*exp(-am_evalue(pbm_ind)*6*Tz)...
            aNG_Ey_xz(:,:,pbm_ind)*exp(-am_evalue(pbm_ind)*5*Tz)...
            aNG_Ey_xz(:,:,pbm_ind)*exp(-am_evalue(pbm_ind)*4*Tz)...
            aNG_Ey_xz(:,:,pbm_ind)*exp(-am_evalue(pbm_ind)*3*Tz)...    
            aNG_Ey_xz(:,:,pbm_ind)*exp(-am_evalue(pbm_ind)*2*Tz)...
            aNG_Ey_xz(:,:,pbm_ind)*exp(-am_evalue(pbm_ind)*Tz)...
            aNG_Ey_xz(:,:,pbm_ind)]; 
            

            
         	aGEz_xz=aGEz_xz+C_n(pbm_ind)*[ aNG_Ez_xz(:,:,pbm_ind)*exp(-am_evalue(pbm_ind)*9*Tz) ...
            aNG_Ez_xz(:,:,pbm_ind)*exp(-am_evalue(pbm_ind)*8*Tz) ...
            aNG_Ez_xz(:,:,pbm_ind)*exp(-am_evalue(pbm_ind)*7*Tz) ...
            aNG_Ez_xz(:,:,pbm_ind)*exp(-am_evalue(pbm_ind)*6*Tz) ... 
            aNG_Ez_xz(:,:,pbm_ind)*exp(-am_evalue(pbm_ind)*5*Tz) ...
            aNG_Ez_xz(:,:,pbm_ind)*exp(-am_evalue(pbm_ind)*4*Tz) ...
            aNG_Ez_xz(:,:,pbm_ind)*exp(-am_evalue(pbm_ind)*3*Tz) ...
            aNG_Ez_xz(:,:,pbm_ind)*exp(-am_evalue(pbm_ind)*2*Tz) ...
            aNG_Ez_xz(:,:,pbm_ind)*exp(-am_evalue(pbm_ind)*Tz) ...
            aNG_Ez_xz(:,:,pbm_ind)]; 
        
        
           aGHx_xz=aGHx_xz+C_n(pbm_ind)*[aNG_Hx_xz(:,:,pbm_ind)*exp(-am_evalue(pbm_ind)*9*Tz) ...
            aNG_Hx_xz(:,:,pbm_ind)*exp(-am_evalue(pbm_ind)*8*Tz) ...
            aNG_Hx_xz(:,:,pbm_ind)*exp(-am_evalue(pbm_ind)*7*Tz) ...    
            aNG_Hx_xz(:,:,pbm_ind)*exp(-am_evalue(pbm_ind)*6*Tz) ...
            aNG_Hx_xz(:,:,pbm_ind)*exp(-am_evalue(pbm_ind)*5*Tz) ...
            aNG_Hx_xz(:,:,pbm_ind)*exp(-am_evalue(pbm_ind)*4*Tz) ...
            aNG_Hx_xz(:,:,pbm_ind)*exp(-am_evalue(pbm_ind)*3*Tz) ...    
            aNG_Hx_xz(:,:,pbm_ind)*exp(-am_evalue(pbm_ind)*2*Tz) ...
            aNG_Hx_xz(:,:,pbm_ind)*exp(-am_evalue(pbm_ind)*Tz) ...
            aNG_Hx_xz(:,:,pbm_ind)]; 
                        
            aGHy_xz=aGHy_xz+C_n(pbm_ind)*[aNG_Hy_xz(:,:,pbm_ind)*exp(-am_evalue(pbm_ind)*9*Tz)...
            aNG_Hy_xz(:,:,pbm_ind)*exp(-am_evalue(pbm_ind)*8*Tz)...    
            aNG_Hy_xz(:,:,pbm_ind)*exp(-am_evalue(pbm_ind)*7*Tz)...
            aNG_Hy_xz(:,:,pbm_ind)*exp(-am_evalue(pbm_ind)*6*Tz)...
            aNG_Hy_xz(:,:,pbm_ind)*exp(-am_evalue(pbm_ind)*5*Tz)...
            aNG_Hy_xz(:,:,pbm_ind)*exp(-am_evalue(pbm_ind)*4*Tz)...
            aNG_Hy_xz(:,:,pbm_ind)*exp(-am_evalue(pbm_ind)*3*Tz)...    
            aNG_Hy_xz(:,:,pbm_ind)*exp(-am_evalue(pbm_ind)*2*Tz)...
            aNG_Hy_xz(:,:,pbm_ind)*exp(-am_evalue(pbm_ind)*Tz)...
            aNG_Hy_xz(:,:,pbm_ind)]; 
            

         	aGHz_xz=aGHz_xz+C_n(pbm_ind)*[ aNG_Hz_xz(:,:,pbm_ind)*exp(-am_evalue(pbm_ind)*9*Tz) ...
            aNG_Hz_xz(:,:,pbm_ind)*exp(-am_evalue(pbm_ind)*8*Tz) ...
            aNG_Hz_xz(:,:,pbm_ind)*exp(-am_evalue(pbm_ind)*7*Tz) ...
            aNG_Hz_xz(:,:,pbm_ind)*exp(-am_evalue(pbm_ind)*6*Tz) ... 
            aNG_Hz_xz(:,:,pbm_ind)*exp(-am_evalue(pbm_ind)*5*Tz) ...
            aNG_Hz_xz(:,:,pbm_ind)*exp(-am_evalue(pbm_ind)*4*Tz) ...
            aNG_Hz_xz(:,:,pbm_ind)*exp(-am_evalue(pbm_ind)*3*Tz) ...
            aNG_Hz_xz(:,:,pbm_ind)*exp(-am_evalue(pbm_ind)*2*Tz) ...
            aNG_Hz_xz(:,:,pbm_ind)*exp(-am_evalue(pbm_ind)*Tz) ...
            aNG_Hz_xz(:,:,pbm_ind)]; 
                  
    end;
    
         aGEx_xz=aGEx_xz+[aPG_Ex_xz(:,:,inc_mode)*exp(-ap_evalue(inc_mode)*10*Tz) ...
                             aPG_Ex_xz(:,:,inc_mode)*exp(-ap_evalue(inc_mode)*9*Tz) ...
                             aPG_Ex_xz(:,:,inc_mode)*exp(-ap_evalue(inc_mode)*8*Tz) ...    
                             aPG_Ex_xz(:,:,inc_mode)*exp(-ap_evalue(inc_mode)*7*Tz) ... 
                             aPG_Ex_xz(:,:,inc_mode)*exp(-ap_evalue(inc_mode)*6*Tz) ...
                             aPG_Ex_xz(:,:,inc_mode)*exp(-ap_evalue(inc_mode)*5*Tz) ...
                             aPG_Ex_xz(:,:,inc_mode)*exp(-ap_evalue(inc_mode)*4*Tz) ...    
                             aPG_Ex_xz(:,:,inc_mode)*exp(-ap_evalue(inc_mode)*3*Tz) ... 
                             aPG_Ex_xz(:,:,inc_mode)*exp(-ap_evalue(inc_mode)*2*Tz) ...
                             aPG_Ex_xz(:,:,inc_mode)*exp(-ap_evalue(inc_mode)*Tz)]; 
          
          aGEy_xz=aGEy_xz+[aPG_Ey_xz(:,:,inc_mode)*exp(-ap_evalue(inc_mode)*10*Tz)...
                             aPG_Ey_xz(:,:,inc_mode)*exp(-ap_evalue(inc_mode)*9*Tz)...    
                             aPG_Ey_xz(:,:,inc_mode)*exp(-ap_evalue(inc_mode)*8*Tz)...
                             aPG_Ey_xz(:,:,inc_mode)*exp(-ap_evalue(inc_mode)*7*Tz)...
                             aPG_Ey_xz(:,:,inc_mode)*exp(-ap_evalue(inc_mode)*6*Tz)...
                             aPG_Ey_xz(:,:,inc_mode)*exp(-ap_evalue(inc_mode)*5*Tz)...    
                             aPG_Ey_xz(:,:,inc_mode)*exp(-ap_evalue(inc_mode)*4*Tz)...
                             aPG_Ey_xz(:,:,inc_mode)*exp(-ap_evalue(inc_mode)*3*Tz)...
                             aPG_Ey_xz(:,:,inc_mode)*exp(-ap_evalue(inc_mode)*2*Tz) ...
                             aPG_Ey_xz(:,:,inc_mode)*exp(-ap_evalue(inc_mode)*Tz)]; 
 
          	aGEz_xz=aGEz_xz+[aPG_Ez_xz(:,:,inc_mode)*exp(-ap_evalue(inc_mode)*10*Tz) ...
                             aPG_Ez_xz(:,:,inc_mode)*exp(-ap_evalue(inc_mode)*9*Tz) ...
                             aPG_Ez_xz(:,:,inc_mode)*exp(-ap_evalue(inc_mode)*8*Tz) ...
                             aPG_Ez_xz(:,:,inc_mode)*exp(-ap_evalue(inc_mode)*7*Tz) ... 
                             aPG_Ez_xz(:,:,inc_mode)*exp(-ap_evalue(inc_mode)*6*Tz) ...
                             aPG_Ez_xz(:,:,inc_mode)*exp(-ap_evalue(inc_mode)*5*Tz) ...
                             aPG_Ez_xz(:,:,inc_mode)*exp(-ap_evalue(inc_mode)*4*Tz) ...
                             aPG_Ez_xz(:,:,inc_mode)*exp(-ap_evalue(inc_mode)*3*Tz) ... 
                             aPG_Ez_xz(:,:,inc_mode)*exp(-ap_evalue(inc_mode)*2*Tz)  ... 
                             aPG_Ez_xz(:,:,inc_mode)*exp(-ap_evalue(inc_mode)*Tz)]; 

            aGHx_xz=aGHx_xz+[aPG_Hx_xz(:,:,inc_mode)*exp(-ap_evalue(inc_mode)*10*Tz) ...
                             aPG_Hx_xz(:,:,inc_mode)*exp(-ap_evalue(inc_mode)*9*Tz) ...
                             aPG_Hx_xz(:,:,inc_mode)*exp(-ap_evalue(inc_mode)*8*Tz) ...    
                             aPG_Hx_xz(:,:,inc_mode)*exp(-ap_evalue(inc_mode)*7*Tz) ... 
                             aPG_Hx_xz(:,:,inc_mode)*exp(-ap_evalue(inc_mode)*6*Tz) ...
                             aPG_Hx_xz(:,:,inc_mode)*exp(-ap_evalue(inc_mode)*5*Tz) ...
                             aPG_Hx_xz(:,:,inc_mode)*exp(-ap_evalue(inc_mode)*4*Tz) ...    
                             aPG_Hx_xz(:,:,inc_mode)*exp(-ap_evalue(inc_mode)*3*Tz) ... 
                             aPG_Hx_xz(:,:,inc_mode)*exp(-ap_evalue(inc_mode)*2*Tz) ...
                             aPG_Hx_xz(:,:,inc_mode)*exp(-ap_evalue(inc_mode)*Tz)]; 
                         
            aGHy_xz=aGHy_xz+[aPG_Hy_xz(:,:,inc_mode)*exp(-ap_evalue(inc_mode)*10*Tz)...
                             aPG_Hy_xz(:,:,inc_mode)*exp(-ap_evalue(inc_mode)*9*Tz)...    
                             aPG_Hy_xz(:,:,inc_mode)*exp(-ap_evalue(inc_mode)*8*Tz)...
                             aPG_Hy_xz(:,:,inc_mode)*exp(-ap_evalue(inc_mode)*7*Tz)...
                             aPG_Hy_xz(:,:,inc_mode)*exp(-ap_evalue(inc_mode)*6*Tz)...
                             aPG_Hy_xz(:,:,inc_mode)*exp(-ap_evalue(inc_mode)*5*Tz)...    
                             aPG_Hy_xz(:,:,inc_mode)*exp(-ap_evalue(inc_mode)*4*Tz)...
                             aPG_Hy_xz(:,:,inc_mode)*exp(-ap_evalue(inc_mode)*3*Tz)...
                             aPG_Hy_xz(:,:,inc_mode)*exp(-ap_evalue(inc_mode)*2*Tz) ...
                             aPG_Hy_xz(:,:,inc_mode)*exp(-ap_evalue(inc_mode)*Tz)]; 
            
          	aGHz_xz=aGHz_xz+[aPG_Hz_xz(:,:,inc_mode)*exp(-ap_evalue(inc_mode)*10*Tz) ...
                             aPG_Hz_xz(:,:,inc_mode)*exp(-ap_evalue(inc_mode)*9*Tz) ...
                             aPG_Hz_xz(:,:,inc_mode)*exp(-ap_evalue(inc_mode)*8*Tz) ...
                             aPG_Hz_xz(:,:,inc_mode)*exp(-ap_evalue(inc_mode)*7*Tz) ... 
                             aPG_Hz_xz(:,:,inc_mode)*exp(-ap_evalue(inc_mode)*6*Tz) ...
                             aPG_Hz_xz(:,:,inc_mode)*exp(-ap_evalue(inc_mode)*5*Tz) ...
                             aPG_Hz_xz(:,:,inc_mode)*exp(-ap_evalue(inc_mode)*4*Tz) ...
                             aPG_Hz_xz(:,:,inc_mode)*exp(-ap_evalue(inc_mode)*3*Tz) ... 
                             aPG_Hz_xz(:,:,inc_mode)*exp(-ap_evalue(inc_mode)*2*Tz)  ... 
                             aPG_Hz_xz(:,:,inc_mode)*exp(-ap_evalue(inc_mode)*Tz)]; 
   
figure(1); imagesc(real([aGEx_xz Ex_xz2])); colorbar; title('Ex-xz'); 
figure(2); imagesc(real([aGEy_xz Ey_xz2])); colorbar; title('Ey-xz');
figure(3); imagesc(real([aGEz_xz Ez_xz2])); colorbar; title('Ez-xz'); 

figure(4); imagesc(real([aGHx_xz Hx_xz2])); colorbar; title('Hx-xz'); 
figure(5); imagesc(real([aGHy_xz Hy_xz2])); colorbar; title('Hy-xz'); 
figure(6); imagesc(real([aGHz_xz Hz_xz2])); colorbar; title('Hz-xz'); 
  

